Index: codes/icosagcm/trunk/src/check_conserve.f90
===================================================================
--- codes/icosagcm/trunk/src/check_conserve.f90	(revision 150)
+++ codes/icosagcm/trunk/src/check_conserve.f90	(revision 151)
@@ -1,24 +1,24 @@
 MODULE check_conserve_mod
-	USE icosa 
-	IMPLICIT NONE 
-
-	PRIVATE 
-     TYPE(t_field),POINTER,SAVE :: f_pk(:), f_pks(:), f_p(:)
-     TYPE(t_field),POINTER,SAVE :: f_vort(:)
-     TYPE(t_field),POINTER,SAVE :: f_rhodz(:) 
+  USE icosa 
+  IMPLICIT NONE 
+
+  PRIVATE 
+    TYPE(t_field),POINTER,SAVE :: f_pk(:), f_pks(:), f_p(:)
+    TYPE(t_field),POINTER,SAVE :: f_vort(:)
+    TYPE(t_field),POINTER,SAVE :: f_rhodz(:) 
    
-     PUBLIC compute_conserve 
-     REAL(rstd),SAVE:: mtot0,ztot0,etot0,ang0,stot0,rmsv0
-     REAL(rstd),SAVE::rmsdpdt,etot,ang,stot,rmsv
-     REAL(rstd),SAVE:: ztot,mtot
+  PUBLIC init_check_conserve, check_conserve 
+    REAL(rstd),SAVE:: mtot0,ztot0,etot0,ang0,stot0,rmsv0
+    REAL(rstd),SAVE::rmsdpdt,etot,ang,stot,rmsv
+    REAL(rstd),SAVE:: ztot,mtot
 	
      
-Contains 
-
-!---------------------------------------------------------------------
-
-   SUBROUTINE allocate_check_conserve
-    USE icosa
-    IMPLICIT NONE
+CONTAINS 
+
+!---------------------------------------------------------------------
+
+  SUBROUTINE init_check_conserve
+  USE icosa
+  IMPLICIT NONE
     CALL allocate_field(f_pk,field_t,type_real,llm)
     CALL allocate_field(f_p,field_t,type_real,llm+1)
@@ -26,9 +26,73 @@
     CALL allocate_field(f_rhodz,field_t,type_real,llm)
     CALL allocate_field(f_vort,field_z,type_real,llm)
-   END SUBROUTINE allocate_check_conserve
-
-!---------------------------------------------------------------------
-
-   SUBROUTINE check_mass_conserve(f_ps,f_dps)
+  END SUBROUTINE init_check_conserve
+
+  SUBROUTINE check_conserve(f_ps,f_dps,f_ue,f_theta_rhodz,f_phis,it) 
+  USE icosa 
+  USE pression_mod
+  USE vorticity_mod
+  USE caldyn_gcm_mod
+  USE exner_mod 
+  USE mpipara
+  IMPLICIT NONE
+    TYPE(t_field),POINTER :: f_ps(:)
+    TYPE(t_field),POINTER :: f_dps(:)
+    TYPE(t_field),POINTER :: f_ue(:)
+    TYPE(t_field),POINTER :: f_theta_rhodz(:)
+    TYPE(t_field),POINTER :: f_phis(:)
+    INTEGER::it 
+    REAL(rstd),POINTER :: p(:,:),rhodz(:,:) 
+    INTEGER::ind 
+
+    etot=0.0; ang=0.0;stot=0.0;rmsv=0.0 
+    mtot=0.0 ; rmsdpdt=0.0 ; ztot = 0.0 
+
+    CALL pression(f_ps,f_p)
+
+    DO ind=1,ndomain 
+      CALL swap_dimensions(ind)
+      CALL swap_geometry(ind)
+        p=f_p(ind) 
+       rhodz=f_rhodz(ind)
+      CALL compute_rhodz(p,rhodz) 
+    END DO 
+
+    CALL vorticity(f_ue,f_vort)
+    CALL check_mass_conserve(f_ps,f_dps)
+    CALL check_PV 
+    CALL exner(f_ps,f_p,f_pks,f_pk)
+    CALL check_EN(f_ue,f_theta_rhodz,f_phis) 
+       
+     IF ( it == 0  ) Then 
+       ztot0 = ztot
+       mtot0 = mtot
+       etot0 = etot 
+       ang0  = ang 
+       stot0 = stot 
+     END IF 
+
+     rmsv=SQRT(rmsv/mtot) 
+     ztot=ztot/ztot0 ; mtot=mtot/mtot0 
+     etot=etot/etot0 ; ang=ang/ang0 ; stot=stot/stot0 
+     rmsdpdt= daysec*1.e-2*sqrt(rmsdpdt/ncell_glo)  
+
+
+     IF (is_mpi_root) THEN 
+       OPEN(134,file="checkconsicosa.txt",position='append')
+       WRITE(134,4000)mtot,rmsdpdt,etot,ztot,stot,rmsv,ang
+       WRITE(134,*)mtot,rmsdpdt,etot,ztot,stot,rmsv,ang 
+       WRITE(134,*)"=================================================="
+       WRITE(*,4000)mtot,rmsdpdt,etot,ztot,stot,rmsv,ang
+
+4000   FORMAT(10x,'masse',4x,'rmsdpdt',7x,'energie',2x,'enstrophie'  &
+     ,2x,'entropie',3x,'rmsv',4x,'mt.ang',/,'GLOB  '                &
+      ,f10.6,e13.6,5f10.3/)     
+       close(134) 
+     END IF 
+  END SUBROUTINE check_conserve
+  
+!---------------------------------------------------------------------
+
+  SUBROUTINE check_mass_conserve(f_ps,f_dps)
   USE icosa
   IMPLICIT NONE
@@ -38,5 +102,5 @@
     INTEGER :: ind,i,j,ij  
 
-   DO ind=1,ndomain
+    DO ind=1,ndomain
       CALL swap_dimensions(ind)
       CALL swap_geometry(ind)
@@ -49,5 +113,5 @@
             mtot=mtot+ps(ij)*Ai(ij)
 	       rmsdpdt=rmsdpdt+dps(ij)*dps(ij)
-	     ENDIF
+	  ENDIF
         ENDDO
       ENDDO
@@ -57,9 +121,9 @@
 !---------------------------------------------------------------------
 
-   SUBROUTINE check_EN(f_ue,f_theta_rhodz,f_phis) 
-    USE icosa
-    USE pression_mod
-    USE vorticity_mod
-    IMPLICIT NONE
+  SUBROUTINE check_en(f_ue,f_theta_rhodz,f_phis) 
+  USE icosa
+  USE pression_mod
+  USE vorticity_mod
+  IMPLICIT NONE
     TYPE(t_field), POINTER :: f_ue(:)
     TYPE(t_field), POINTER :: f_theta_rhodz(:)
@@ -74,22 +138,23 @@
 
 
-      Do ind=1,ndomain 
-        CALL swap_dimensions(ind)
-        CALL swap_geometry(ind)
-	 ue=f_ue(ind) 
-         p=f_p(ind)
-         rhodz=f_rhodz(ind) 
-         theta_rhodz=f_theta_rhodz(ind) 
-	    pk=f_pk(ind) 
-	    phis=f_phis(ind) 
-        CALL compute_en(ind,ue,p,rhodz,theta_rhodz,pk,phis)
-	 END DO 
-  END SUBROUTINE CHECK_EN 
-
-   SUBROUTINE compute_en(ind,u,p,rhodz,theta_rhodz,pk,phis)
-	 USE icosa
-      USE disvert_mod
-      USE wind_mod
-     IMPLICIT NONE
+    DO ind=1,ndomain 
+      CALL swap_dimensions(ind)
+      CALL swap_geometry(ind)
+      ue=f_ue(ind) 
+      p=f_p(ind)
+      rhodz=f_rhodz(ind) 
+      theta_rhodz=f_theta_rhodz(ind) 
+      pk=f_pk(ind) 
+      phis=f_phis(ind) 
+      CALL compute_en(ind,ue,p,rhodz,theta_rhodz,pk,phis)
+    END DO 
+ 
+  END SUBROUTINE check_en 
+
+  SUBROUTINE compute_en(ind,u,p,rhodz,theta_rhodz,pk,phis)
+  USE icosa
+  USE disvert_mod
+  USE wind_mod
+  IMPLICIT NONE
     INTEGER,INTENT(IN)::ind 
     REAL(rstd),INTENT(IN) :: u(3*iim*jjm,llm)
@@ -110,89 +175,88 @@
 
   
-       DO l = 1, llm
-        DO j=jj_begin,jj_end
-         DO i=ii_begin,ii_end
-	        ij=(j-1)*iim+i
-	         masse(ij,l) = rhodz(ij,l)*Ai(ij) 
-              theta(ij,l) = theta_rhodz(ij,l)/rhodz(ij,l)
-             IF (domain(ind)%own(i,j)) THEN
-	         stot = stot + Ai(ij)*theta_rhodz(ij,l)
-             END IF 
-          END DO 
-         END DO
-	   END DO 
-
-       DO l = 1, llm
-        DO j=jj_begin,jj_end
-         DO i=ii_begin,ii_end
-	        ij=(j-1)*iim+i
-           IF (domain(ind)%own(i,j)) THEN
-	        KE(ij,l)=   1/(4*Ai(ij))*(le(ij+u_right)*de(ij+u_right)*u(ij+u_right,l)**2 +   &
-                                     le(ij+u_rup)*de(ij+u_rup)*u(ij+u_rup,l)**2 +           &
-                                     le(ij+u_lup)*de(ij+u_lup)*u(ij+u_lup,l)**2 +           &
-                                     le(ij+u_left)*de(ij+u_left)*u(ij+u_left,l)**2 +        &
-                                     le(ij+u_ldown)*de(ij+u_ldown)*u(ij+u_ldown,l)**2 +     &
-                                     le(ij+u_rdown)*de(ij+u_rdown)*u(ij+u_rdown,l)**2 )  
-             rmsv = rmsv + 2*masse(ij,l)*KE(ij,l) 
-            END IF 
-	     END DO
-         END DO 
-        END DO  
-
-       DO l = 1, llm
-        DO j=jj_begin,jj_end
-         DO i=ii_begin,ii_end
-	        ij=(j-1)*iim+i
-           IF (domain(ind)%own(i,j)) THEN
-	      etot = etot + masse(ij,l)*(phis(ij)+theta(ij,l)*pk(ij,l)+KE(ij,l))
-           END IF 
-          END DO 
+    DO l = 1, llm
+      DO j=jj_begin,jj_end
+        DO i=ii_begin,ii_end
+	  ij=(j-1)*iim+i
+	  masse(ij,l) = rhodz(ij,l)*Ai(ij) 
+          theta(ij,l) = theta_rhodz(ij,l)/rhodz(ij,l)
+          IF (domain(ind)%own(i,j)) THEN
+	    stot = stot + Ai(ij)*theta_rhodz(ij,l)
+          END IF 
         END DO 
-       END DO 
+      END DO
+    END DO 
+
+    DO l = 1, llm
+      DO j=jj_begin,jj_end
+        DO i=ii_begin,ii_end
+          ij=(j-1)*iim+i
+          IF (domain(ind)%own(i,j)) THEN
+	    KE(ij,l)=   1/(4*Ai(ij))*(le(ij+u_right)*de(ij+u_right)*u(ij+u_right,l)**2 +   &
+                                      le(ij+u_rup)*de(ij+u_rup)*u(ij+u_rup,l)**2 +           &
+                                      le(ij+u_lup)*de(ij+u_lup)*u(ij+u_lup,l)**2 +           &
+                                      le(ij+u_left)*de(ij+u_left)*u(ij+u_left,l)**2 +        &
+                                      le(ij+u_ldown)*de(ij+u_ldown)*u(ij+u_ldown,l)**2 +     &
+                                      le(ij+u_rdown)*de(ij+u_rdown)*u(ij+u_rdown,l)**2 )  
+            rmsv = rmsv + 2*masse(ij,l)*KE(ij,l) 
+          END IF 
+        END DO
+      END DO 
+    END DO  
+
+    DO l = 1, llm
+      DO j=jj_begin,jj_end
+        DO i=ii_begin,ii_end
+	  ij=(j-1)*iim+i
+          IF (domain(ind)%own(i,j)) THEN
+	    etot = etot + masse(ij,l)*(phis(ij)+theta(ij,l)*pk(ij,l)+KE(ij,l))
+          END IF 
+        END DO 
+      END DO 
+    END DO 
 
 !------------------------------ ANGULAR VELOCITY 
-	CALL compute_wind_centered(u,ucenter)
-     CALL compute_wind_centered_lonlat_compound(ucenter,ulon,ulat)
-	 rad = radius 
-      radomeg = rad*omega
-
-      DO l = 1, llm
-        DO j=jj_begin,jj_end
-         DO i=ii_begin,ii_end
-	        ij=(j-1)*iim+i
-           IF (domain(ind)%own(i,j)) THEN
-             CALL xyz2lonlat(xyz_i(ij,:),lon,lat) 
-                ang=ang+rad*cos(lat)*masse(ij,l)*(ulon(ij,l)+ radomeg*cos(lat))
-           END IF 
-         END DO
-       END DO
-      END DO    
+    CALL compute_wind_centered(u,ucenter)
+    CALL compute_wind_centered_lonlat_compound(ucenter,ulon,ulat)
+    rad = radius 
+    radomeg = rad*omega
+
+    DO l = 1, llm
+      DO j=jj_begin,jj_end
+        DO i=ii_begin,ii_end
+	  ij=(j-1)*iim+i
+          IF (domain(ind)%own(i,j)) THEN
+            CALL xyz2lonlat(xyz_i(ij,:),lon,lat) 
+            ang=ang+rad*cos(lat)*masse(ij,l)*(ulon(ij,l)+ radomeg*cos(lat))
+          END IF 
+        END DO
+      END DO
+    END DO    
           
-	END SUBROUTINE compute_en
-
-!---------------------------------------------------------------------
-
-   SUBROUTINE check_PV 
-    USE icosa
-    IMPLICIT NONE
-
-    REAL(rstd), POINTER :: vort(:,:)
-    REAL(rstd), POINTER :: rhodz(:,:) 
-    INTEGER :: ind
-
-    Do ind=1,ndomain 
-      CALL swap_dimensions(ind)
-      CALL swap_geometry(ind)
-      vort=f_vort(ind)
-      rhodz=f_rhodz(ind) 
-      CALL compute_PV(vort,rhodz) 
-    ENDDO
+  END SUBROUTINE compute_en
+
+!---------------------------------------------------------------------
+
+  SUBROUTINE check_PV 
+  USE icosa
+  IMPLICIT NONE
+     REAL(rstd), POINTER :: vort(:,:)
+     REAL(rstd), POINTER :: rhodz(:,:) 
+     INTEGER :: ind
+
+     DO ind=1,ndomain 
+       CALL swap_dimensions(ind)
+       CALL swap_geometry(ind)
+       vort=f_vort(ind)
+       rhodz=f_rhodz(ind) 
+       CALL compute_PV(vort,rhodz) 
+     ENDDO
  
-   END SUBROUTINE check_PV 
-
-	SUBROUTINE compute_PV(vort,rhodz) 
-	  USE icosa
-      USE disvert_mod
-     IMPLICIT NONE 
+  END SUBROUTINE check_PV 
+
+  SUBROUTINE compute_PV(vort,rhodz) 
+  USE icosa
+  USE disvert_mod
+  IMPLICIT NONE 
     REAL(rstd),INTENT(IN) :: vort(2*iim*jjm,llm)
     REAL(rstd),INTENT(IN) :: rhodz(iim*jjm,llm) 
@@ -201,32 +265,34 @@
     INTEGER :: i,j,ij,l,ij2
 
-	hv1 = 0.0 ; hv2 = 0.0 
+    hv1 = 0.0 ; hv2 = 0.0 
    
-     DO l = 1,llm
+    DO l = 1,llm
       DO j=jj_begin+1,jj_end-1
-       DO i=ii_begin+1,ii_end-1
-           ij=(j-1)*iim+i
-            hv1 =  Riv2(ij,vup)        * rhodz(ij,l)           &
-              + Riv2(ij+t_rup,vldown) * rhodz(ij+t_rup,l)     &
-              + Riv2(ij+t_lup,vrdown) * rhodz(ij+t_lup,l)
-      
-            qv1 = ( vort(ij+z_up,l)+fv(ij+z_up) )/hv1
-            
-            hv2  =  Riv2(ij,vdown)     * rhodz(ij,l)          &
-              + Riv2(ij+t_ldown,vrup) * rhodz(ij+t_ldown,l)  &
-              + Riv2(ij+t_rdown,vlup) * rhodz(ij+t_rdown,l)
-                       
-            qv2 =( vort(ij+z_down,l)+fv(ij+z_down) )/hv2
-
-            ztot = ztot + (qv1*qv1*hv1 + qv2*qv2*hv2) 
-	  ENDDO
-         ENDDO
+        DO i=ii_begin+1,ii_end-1
+          ij=(j-1)*iim+i
+          hv1 =  Riv2(ij,vup)        * rhodz(ij,l)           &
+            + Riv2(ij+t_rup,vldown) * rhodz(ij+t_rup,l)     &
+            + Riv2(ij+t_lup,vrdown) * rhodz(ij+t_lup,l)
+    
+          qv1 = ( vort(ij+z_up,l)+fv(ij+z_up) )/hv1
+          
+          hv2  =  Riv2(ij,vdown)     * rhodz(ij,l)          &
+            + Riv2(ij+t_ldown,vrup) * rhodz(ij+t_ldown,l)  &
+            + Riv2(ij+t_rdown,vlup) * rhodz(ij+t_rdown,l)
+                     
+          qv2 =( vort(ij+z_down,l)+fv(ij+z_down) )/hv2
+
+          ztot = ztot + (qv1*qv1*hv1 + qv2*qv2*hv2) 
+
         ENDDO
-    END SUBROUTINE compute_PV
-!---------------------------------------------------------------------
-
-    SUBROUTINE compute_rhodz(p,rhodz) 
-	USE icosa 
-	IMPLICIT NONE 
+      ENDDO
+    ENDDO
+
+  END SUBROUTINE compute_PV
+!---------------------------------------------------------------------
+
+   SUBROUTINE compute_rhodz(p,rhodz) 
+   USE icosa 
+   IMPLICIT NONE 
      REAL(rstd),INTENT(IN) :: p(iim*jjm,llm+1)
      REAL(rstd),INTENT(OUT):: rhodz(iim*jjm,llm)
@@ -244,71 +310,7 @@
      ENDDO
 
-	END SUBROUTINE compute_rhodz
+   END SUBROUTINE compute_rhodz
 !====================================================================
 
-	SUBROUTINE compute_conserve(f_ps,f_dps,f_ue,f_theta_rhodz,f_phis,it) 
-	 USE icosa 
-      USE pression_mod
-      USE vorticity_mod
-      USE caldyn_gcm_mod
-      USE exner_mod 
-      USE mpipara
-     TYPE(t_field),POINTER :: f_ps(:)
-     TYPE(t_field),POINTER :: f_dps(:)
-     TYPE(t_field),POINTER :: f_ue(:)
-     TYPE(t_field),POINTER :: f_theta_rhodz(:)
-     TYPE(t_field),POINTER :: f_phis(:)
-     INTEGER::it 
-     REAL(rstd),POINTER :: p(:,:),rhodz(:,:) 
-     INTEGER::ind 
-
-     etot=0.0; ang=0.0;stot=0.0;rmsv=0.0 
-     mtot=0.0 ; rmsdpdt=0.0 ; ztot = 0.0 
-
-     CALL allocate_check_conserve
-
-     CALL pression(f_ps,f_p)
-
-     Do ind=1,ndomain 
-       CALL swap_dimensions(ind)
-       CALL swap_geometry(ind)
-         p=f_p(ind) 
-        rhodz=f_rhodz(ind)
-       CALL compute_rhodz(p,rhodz) 
-      END DO 
-
-     CALL vorticity(f_ue,f_vort)
-     CALL check_mass_conserve(f_ps,f_dps)
-     CALL check_PV 
-     CALL exner(f_ps,f_p,f_pks,f_pk)
-     CALL check_EN(f_ue,f_theta_rhodz,f_phis) 
-    	
-	   IF ( it == 0  ) Then 
-	   ztot0 = ztot
-           mtot0 = mtot
-           etot0 = etot 
-           ang0  = ang 
-           stot0 = stot 
-        END IF 
-
-      rmsv=SQRT(rmsv/mtot) 
-      ztot=ztot/ztot0 ; mtot=mtot/mtot0 
-      etot=etot/etot0 ; ang=ang/ang0 ; stot=stot/stot0 
-      rmsdpdt= daysec*1.e-2*sqrt(rmsdpdt/ncell_glo)  
-
-
-	  IF (is_mpi_root) THEN 
-       OPEN(134,file="checkconsicosa.txt",position='append')
-       write(134,4000)mtot,rmsdpdt,etot,ztot,stot,rmsv,ang
-       write(134,*)mtot,rmsdpdt,etot,ztot,stot,rmsv,ang 
-       write(134,*)"=================================================="
-       write(*,4000)mtot,rmsdpdt,etot,ztot,stot,rmsv,ang
-
-4000   FORMAT(10x,'masse',4x,'rmsdpdt',7x,'energie',2x,'enstrophie'  &
-      ,2x,'entropie',3x,'rmsv',4x,'mt.ang',/,'GLOB  '                &
-       ,f10.6,e13.6,5f10.3/)     
-       close(134) 
-       END IF 
-    END SUBROUTINE compute_conserve
 
  END MODULE check_conserve_mod
Index: codes/icosagcm/trunk/src/dimensions.f90
===================================================================
--- codes/icosagcm/trunk/src/dimensions.f90	(revision 150)
+++ codes/icosagcm/trunk/src/dimensions.f90	(revision 151)
@@ -44,4 +44,6 @@
     TYPE(t_domain),POINTER :: d
     
+    
+!$OMP MASTER
     d=>domain(ind)
      
@@ -79,5 +81,7 @@
      u_pos(:)=d%u_pos(:)
      z_pos(:)=d%z_pos(:)
-     
+
+!$OMP END MASTER     
+!$OMP BARRIER
    END SUBROUTINE swap_dimensions
    
Index: codes/icosagcm/trunk/src/dissip_gcm.f90
===================================================================
--- codes/icosagcm/trunk/src/dissip_gcm.f90	(revision 150)
+++ codes/icosagcm/trunk/src/dissip_gcm.f90	(revision 151)
@@ -10,5 +10,5 @@
   TYPE(t_field),POINTER,SAVE :: f_dtheta_diss(:)
   TYPE(t_field),POINTER,SAVE :: f_dtheta_rhodz_diss(:)
-  
+  TYPE(t_message) :: req_due, req_dtheta 
  
   INTEGER,SAVE :: nitergdiv=1
@@ -29,5 +29,5 @@
 !  INTEGER,SAVE :: itau_dissip
   REAL,SAVE    :: dtdissip
-  
+ 
   PUBLIC init_dissip, dissip
 CONTAINS
@@ -57,4 +57,5 @@
   USE mpi_mod
   USE mpipara
+  USE transfert_mod
   USE time_mod
   
@@ -96,6 +97,5 @@
       IF (is_mpi_root) PRINT *, 'Rayleigh friction : Schaer-like mountain with shear DCMIP2.2'
    CASE DEFAULT
-      IF (is_mpi_root) PRINT *, 'Bad selector : rayleigh_friction_type =', TRIM(rayleigh_friction_key), & 
-        ' in dissip_gcm.f90/init_dissip'
+      IF (is_mpi_root) PRINT *, 'Bad selector : rayleigh_friction_type =', TRIM(rayleigh_friction_key), ' in dissip_gcm.f90/init_dissip'
       STOP
    END SELECT
@@ -116,4 +116,7 @@
     CALL allocate_field(f_theta,field_t,type_real)
     CALL allocate_field(f_dtheta,field_t,type_real)
+    
+    CALL init_message(f_due_diss1,req_e1_vect,req_due)
+    CALL init_message(f_dtheta_diss,req_i1,req_dtheta)
 
     tau_graddiv(:)=5000
@@ -135,44 +138,4 @@
 
     CALL getin("niterdivgrad",niterdivgrad)
-  
-!   CALL create_request(field_u,req_dissip)
-
-!   DO ind=1,ndomain
-!     DO i=ii_begin,ii_end
-!       CALL request_add_point(ind,i,jj_begin-1,req_dissip,rup)
-!       CALL request_add_point(ind,i+1,jj_begin-1,req_dissip,lup)
-!     ENDDO
-
-!     DO j=jj_begin,jj_end
-!       CALL request_add_point(ind,ii_end+1,j,req_dissip,left)
-!       CALL request_add_point(ind,ii_end+1,j-1,req_dissip,lup)
-!     ENDDO    
-!   
-!     DO i=ii_begin,ii_end
-!       CALL request_add_point(ind,i,jj_end+1,req_dissip,ldown)
-!       CALL request_add_point(ind,i-1,jj_end+1,req_dissip,rdown)
-!     ENDDO    
-
-!     DO j=jj_begin,jj_end
-!       CALL request_add_point(ind,ii_begin-1,j,req_dissip,right)
-!       CALL request_add_point(ind,ii_begin-1,j+1,req_dissip,rdown)
-!     ENDDO   
-
-!     DO i=ii_begin+1,ii_end-1
-!       CALL request_add_point(ind,i,jj_begin,req_dissip,right)
-!       CALL request_add_point(ind,i,jj_end,req_dissip,right)
-!     ENDDO
-!   
-!     DO j=jj_begin+1,jj_end-1
-!       CALL request_add_point(ind,ii_begin,j,req_dissip,rup)
-!       CALL request_add_point(ind,ii_end,j,req_dissip,rup)
-!     ENDDO   
-
-!     CALL request_add_point(ind,ii_begin+1,jj_begin,req_dissip,left)
-!     CALL request_add_point(ind,ii_begin,jj_begin+1,req_dissip,ldown)
-!     CALL request_add_point(ind,ii_begin+1,jj_end,req_dissip,left)
-!     CALL request_add_point(ind,ii_end,jj_begin+1,req_dissip,ldown)
-!    
-!   ENDDO
 
 
@@ -214,5 +177,5 @@
           u=f_u(ind)
           du=f_du(ind)
-          CALL compute_gradiv(u,du,1)
+          CALL compute_gradiv(u,du,1,1)
           u=du
         ENDDO
@@ -238,5 +201,5 @@
 
       IF (using_mpi) THEN 
-			  CALL MPI_ALLREDUCE(dumax,dumax1,1,MPI_REAL8,MPI_MAX,comm_icosa,ierr)
+        CALL MPI_ALLREDUCE(dumax,dumax1,1,MPI_REAL8,MPI_MAX,comm_icosa,ierr)
         dumax=dumax1
       ENDIF
@@ -291,5 +254,5 @@
           u=f_u(ind)
           du=f_du(ind)
-          CALL compute_gradrot(u,du,1)
+          CALL compute_gradrot(u,du,1,1)
           u=du
         ENDDO
@@ -362,9 +325,8 @@
           theta=f_theta(ind)
           dtheta=f_dtheta(ind)
-          CALL compute_divgrad(theta,dtheta,1)
+          CALL compute_divgrad(theta,dtheta,1,1)
           theta=dtheta
         ENDDO
       ENDDO
-!      CALL writefield("divgrad",f_dtheta)
 
       CALL transfert_request(f_dtheta,req_i1)
@@ -398,14 +360,8 @@
     ENDDO 
 
-!    CALL writefield("divgrad",f_dtheta)
     IF (is_mpi_root) PRINT *,"divgrad : divgrad",dthetamax
   
     cdivgrad=dthetamax**(-1./niterdivgrad) 
     IF (is_mpi_root) PRINT *,"cdivgrad : ",cdivgrad
-    
-
-
-
-
 
      
@@ -442,4 +398,5 @@
   USE trace
   USE time_mod
+  USE omp_para
   IMPLICIT NONE
     TYPE(t_field),POINTER :: f_ue(:)
@@ -458,17 +415,19 @@
     INTEGER :: ind, shear
     INTEGER :: l,i,j,n
+
+!$OMP BARRIER
     
     CALL trace_start("dissip")
     CALL gradiv(f_ue,f_due_diss1)
     CALL gradrot(f_ue,f_due_diss2)
-    CALL theta_rhodz2theta(f_ps,f_theta_rhodz,f_theta)
-    CALL divgrad(f_theta,f_dtheta_diss)
-    CALL theta2theta_rhodz(f_ps,f_dtheta_diss,f_dtheta_rhodz_diss)
-    
-    IF(rayleigh_friction_type>0) THEN
-       CALL pression(f_ps, f_p)
-       CALL exner(f_ps, f_p, f_pks, f_pk)
-       CALL geopotential(f_phis,f_pks,f_pk,f_theta,f_phi)
-    END IF
+    
+    CALL divgrad_theta_rhodz(f_ps,f_theta_rhodz,f_dtheta_rhodz_diss)
+    
+! later for openmp    
+!    IF(rayleigh_friction_type>0) THEN
+!       CALL pression(f_ps, f_p)
+!       CALL exner(f_ps, f_p, f_pks, f_pk)
+!       CALL geopotential(f_phis,f_pks,f_pk,f_theta,f_phi)
+!    END IF
 
     DO ind=1,ndomain
@@ -480,6 +439,6 @@
       dtheta_rhodz=f_dtheta_rhodz(ind)
       dtheta_rhodz_diss=f_dtheta_rhodz_diss(ind)
-            
-      DO l=1,llm
+
+      DO l=ll_begin,ll_end
         DO j=jj_begin,jj_end
           DO i=ii_begin,ii_end
@@ -495,21 +454,27 @@
       ENDDO
 
-      IF(rayleigh_friction_type>0) THEN
-         phi=f_phi(ind)
-         ue=f_ue(ind)
-         DO l=1,llm
-            DO j=jj_begin,jj_end
-               DO i=ii_begin,ii_end
-                  n=(j-1)*iim+i
-                  CALL relax(t_right, u_right)
-                  CALL relax(t_lup,   u_lup)
-                  CALL relax(t_ldown, u_ldown)
-               ENDDO
-            ENDDO
-         END DO
-      END IF
+!      dtheta_rhodz=0
+!      due=0
+
+! later for openmp  
+!      IF(rayleigh_friction_type>0) THEN
+!         phi=f_phi(ind)
+!         ue=f_ue(ind)
+!         DO l=1,llm
+!            DO j=jj_begin,jj_end
+!               DO i=ii_begin,ii_end
+!                  n=(j-1)*iim+i
+!                  CALL relax(t_right, u_right)
+!                  CALL relax(t_lup,   u_lup)
+!                  CALL relax(t_ldown, u_ldown)
+!               ENDDO
+!            ENDDO
+!         END DO
+!      END IF
    END DO
 
    CALL trace_end("dissip")
+
+!$OMP BARRIER
 
     CONTAINS
@@ -524,6 +489,5 @@
         z = (phi(n,l)+phi(n+shift_t,l))/(2.*g)
         IF(z>zh) THEN  ! relax only in the sponge layer z>zh
-!           PRINT *, 'z>zh : z,zh,l',z,zh,l
-!           STOP
+
            nn = n+shift_u
            CALL xyz2lonlat(xyz_e(nn,:),lon,lat)
@@ -548,4 +512,5 @@
   USE icosa
   USE trace
+  USE omp_para
   IMPLICIT NONE
     TYPE(t_field),POINTER :: f_ue(:)
@@ -554,5 +519,5 @@
     REAL(rstd),POINTER    :: due(:,:)
     INTEGER :: ind
-    INTEGER :: it
+    INTEGER :: it,i,j,l,ij
        
     CALL trace_start("gradiv")
@@ -563,10 +528,20 @@
       ue=f_ue(ind)
       due=f_due(ind) 
-      due=ue
+      DO  l = ll_begin, ll_end
+        DO j=jj_begin,jj_end
+          DO i=ii_begin,ii_end
+            ij=(j-1)*iim+i
+             due(ij+u_right,l)=ue(ij+u_right,l)
+             due(ij+u_lup,l)=ue(ij+u_lup,l)
+             due(ij+u_ldown,l)=ue(ij+u_ldown,l)
+          ENDDO
+        ENDDO
+      ENDDO
     ENDDO
 
     DO it=1,nitergdiv
         
-      CALL transfert_request(f_due,req_e1_vect)
+      CALL send_message(f_due,req_due)
+      CALL wait_message(req_due)
         
       DO ind=1,ndomain
@@ -574,5 +549,5 @@
         CALL swap_geometry(ind)
         due=f_due(ind) 
-        CALL compute_gradiv(due,due,llm)
+        CALL compute_gradiv(due,due,ll_begin,ll_end)
       ENDDO
     ENDDO
@@ -586,4 +561,5 @@
   USE icosa
   USE trace
+  USE omp_para
   IMPLICIT NONE
     TYPE(t_field),POINTER :: f_ue(:)
@@ -592,5 +568,5 @@
     REAL(rstd),POINTER    :: due(:,:)
     INTEGER :: ind
-    INTEGER :: it
+    INTEGER :: it,i,j,l,ij
        
     CALL trace_start("gradrot")
@@ -601,10 +577,20 @@
       ue=f_ue(ind)
       due=f_due(ind) 
-      due=ue
+      DO  l = ll_begin, ll_end
+        DO j=jj_begin,jj_end
+          DO i=ii_begin,ii_end
+            ij=(j-1)*iim+i
+             due(ij+u_right,l)=ue(ij+u_right,l)
+             due(ij+u_lup,l)=ue(ij+u_lup,l)
+             due(ij+u_ldown,l)=ue(ij+u_ldown,l)
+          ENDDO
+        ENDDO
+      ENDDO
     ENDDO
 
     DO it=1,nitergrot
         
-      CALL transfert_request(f_due,req_e1_vect)
+      CALL send_message(f_due,req_due)
+      CALL wait_message(req_due)
         
       DO ind=1,ndomain
@@ -612,5 +598,5 @@
         CALL swap_geometry(ind)
         due=f_due(ind) 
-        CALL compute_gradrot(due,due,llm)
+        CALL compute_gradrot(due,due,ll_begin,ll_end)
       ENDDO
 
@@ -624,4 +610,5 @@
   USE icosa
   USE trace
+  USE omp_para
   IMPLICIT NONE
     TYPE(t_field),POINTER :: f_theta(:)
@@ -650,5 +637,5 @@
         CALL swap_geometry(ind)
         dtheta=f_dtheta(ind) 
-        CALL compute_divgrad(dtheta,dtheta,llm)
+        CALL compute_divgrad(dtheta,dtheta,ll_begin,ll_end)
       ENDDO
 
@@ -659,97 +646,84 @@
   END SUBROUTINE divgrad
    
-  
-
-!  SUBROUTINE compute_dissip(ue,due,ps,theta_rhodz,dtheta_rhodz)
-!  USE icosa
-!  USE theta2theta_rhodz_mod
-!  IMPLICIT NONE
-!    REAL(rstd)         :: ue(3*iim*jjm,llm)
-!    REAL(rstd)         :: due(3*iim*jjm,llm)
-!    REAL(rstd)         :: ps(iim*jjm)
-!    REAL(rstd)         :: theta_rhodz(iim*jjm,llm)
-!    REAL(rstd)         :: dtheta_rhodz(iim*jjm,llm)
-!
-!    REAL(rstd),SAVE,ALLOCATABLE :: theta(:,:)
-!    REAL(rstd),SAVE,ALLOCATABLE :: du_dissip(:,:)
-!    REAL(rstd),SAVE,ALLOCATABLE :: dtheta_dissip(:,:)
-!    REAL(rstd),SAVE,ALLOCATABLE :: dtheta_rhodz_dissip(:,:)
-!
-!    INTEGER :: ind
-!    INTEGER :: l,i,j,n
-!
-!!$OMP BARRIER
-!!$OMP MASTER
-!      ALLOCATE(theta(iim*jjm,llm))
-!      ALLOCATE(du_dissip(3*iim*jjm,llm))
-!      ALLOCATE(dtheta_dissip(iim*jjm,llm))
-!      ALLOCATE(dtheta_rhodz_dissip(iim*jjm,llm))
-!!$OMP END MASTER
-!!$OMP BARRIER
-!    
-!      CALL gradiv(ue,du_dissip,llm)
-!      DO l=1,llm
-!!$OMP DO
-!        DO j=jj_begin,jj_end
-!          DO i=ii_begin,ii_end
-!            n=(j-1)*iim+i
-!            due(n+u_right,l)=due(n+u_right,l)+du_dissip(n+u_right,l)/tau_graddiv(l)*0.5
-!            due(n+u_lup,l)=due(n+u_lup,l)+du_dissip(n+u_lup,l)/tau_graddiv(l)*0.5
-!            due(n+u_ldown,l)=due(n+u_ldown,l)+du_dissip(n+u_ldown,l)/tau_graddiv(l)*0.5
-!          ENDDO
-!        ENDDO
-!      ENDDO
-!      
-!      CALL gradrot(ue,du_dissip,llm)
-!
-!      DO l=1,llm
-!!$OMP DO
-!        DO j=jj_begin,jj_end
-!          DO i=ii_begin,ii_end
-!            n=(j-1)*iim+i
-!            due(n+u_right,l)=due(n+u_right,l)+du_dissip(n+u_right,l)/tau_gradrot(l)*0.5
-!            due(n+u_lup,l)=due(n+u_lup,l)+du_dissip(n+u_lup,l)/tau_gradrot(l)*0.5
-!            due(n+u_ldown,l)=due(n+u_ldown,l)+du_dissip(n+u_ldown,l)/tau_gradrot(l)*0.5
-!          ENDDO
-!        ENDDO
-!      ENDDO 
-!      
-!      CALL compute_theta_rhodz2theta(ps,theta_rhodz,theta,1)
-!      CALL divgrad(theta,dtheta_dissip,llm)
-!      CALL compute_theta2theta_rhodz(ps,dtheta_dissip,dtheta_rhodz_dissip,0)
-!
-!      DO l=1,llm
-!!$OMP DO
-!        DO j=jj_begin,jj_end
-!          DO i=ii_begin,ii_end
-!            n=(j-1)*iim+i
-!            dtheta_rhodz(n,l)=dtheta_rhodz(n,l)+dtheta_rhodz_dissip(n,l)/tau_divgrad(l)*0.5
-!          ENDDO
-!        ENDDO
-!      ENDDO 
-!
-!!$OMP BARRIER
-!!$OMP MASTER
-!      DEALLOCATE(theta)
-!      DEALLOCATE(du_dissip)
-!      DEALLOCATE(dtheta_dissip)
-!      DEALLOCATE(dtheta_rhodz_dissip)
-!!$OMP END MASTER
-!!$OMP BARRIER      
-!
-!  END SUBROUTINE compute_dissip
-  
-  
-  SUBROUTINE compute_gradiv(ue,gradivu_e,ll)
-  USE icosa
+  SUBROUTINE divgrad_theta_rhodz(f_ps,f_theta_rhodz,f_dtheta_rhodz)
+  USE icosa
+  USE trace
+  USE omp_para
+  USE disvert_mod
   IMPLICIT NONE
-    INTEGER,INTENT(IN)     :: ll
-    REAL(rstd),INTENT(IN)  :: ue(iim*3*jjm,ll)
-    REAL(rstd),INTENT(OUT) :: gradivu_e(iim*3*jjm,ll)
-    REAL(rstd) :: divu_i(iim*jjm,ll)
+    TYPE(t_field),POINTER :: f_ps(:)
+    TYPE(t_field),POINTER :: f_theta_rhodz(:)
+    TYPE(t_field),POINTER :: f_dtheta_rhodz(:)
+    
+    REAL(rstd),POINTER :: ps(:)
+    REAL(rstd),POINTER :: theta_rhodz(:,:)
+    REAL(rstd),POINTER :: dtheta_rhodz(:,:)
+
+    INTEGER :: ind
+    INTEGER :: it,i,j,l,ij
+
+    CALL trace_start("divgrad")
+       
+    DO ind=1,ndomain
+      CALL swap_dimensions(ind)
+      CALL swap_geometry(ind)
+      ps=f_ps(ind)
+      theta_rhodz=f_theta_rhodz(ind)
+      dtheta_rhodz=f_dtheta_rhodz(ind) 
+      DO  l = ll_begin, ll_end
+        DO j=jj_begin,jj_end
+          DO i=ii_begin,ii_end
+            ij=(j-1)*iim+i
+            dtheta_rhodz(ij,l) = theta_rhodz(ij,l) / ( ap(l)-ap(l+1) + (bp(l)-bp(l+1))*ps(ij))/g
+          ENDDO
+        ENDDO
+      ENDDO
+    ENDDO
+
+    DO it=1,niterdivgrad
+        
+      CALL send_message(f_dtheta_rhodz,req_dtheta)
+      CALL wait_message(req_dtheta)
+      DO ind=1,ndomain
+        CALL swap_dimensions(ind)
+        CALL swap_geometry(ind)
+        dtheta_rhodz=f_dtheta_rhodz(ind) 
+        CALL compute_divgrad(dtheta_rhodz,dtheta_rhodz,ll_begin,ll_end)
+      ENDDO
+
+    ENDDO
+
+    DO ind=1,ndomain
+      CALL swap_dimensions(ind)
+      CALL swap_geometry(ind)
+      dtheta_rhodz=f_dtheta_rhodz(ind) 
+    
+      DO  l = ll_begin, ll_end
+        DO j=jj_begin,jj_end
+          DO i=ii_begin,ii_end
+            ij=(j-1)*iim+i
+            dtheta_rhodz(ij,l) = dtheta_rhodz(ij,l) * ( ap(l)-ap(l+1) + (bp(l)-bp(l+1))*ps(ij))/g
+          ENDDO
+        ENDDO
+      ENDDO
+    ENDDO
+
+
+    CALL trace_end("divgrad")
+
+  END SUBROUTINE divgrad_theta_rhodz  
+  
+  SUBROUTINE compute_gradiv(ue,gradivu_e,llb,lle)
+  USE icosa
+  IMPLICIT NONE
+    INTEGER,INTENT(IN)     :: llb
+    INTEGER,INTENT(IN)     :: lle
+    REAL(rstd),INTENT(IN)  :: ue(iim*3*jjm,llm)
+    REAL(rstd),INTENT(OUT) :: gradivu_e(iim*3*jjm,llm)
+    REAL(rstd) :: divu_i(iim*jjm,llb:lle)
     
     INTEGER :: i,j,n,l
 
-    DO l=1,ll
+    DO l=llb,lle
       DO j=jj_begin,jj_end
         DO i=ii_begin,ii_end
@@ -765,5 +739,5 @@
     ENDDO
     
-    DO l=1,ll
+    DO l=llb,lle
       DO j=jj_begin,jj_end
         DO i=ii_begin,ii_end
@@ -781,5 +755,5 @@
     ENDDO
 
-    DO l=1,ll
+    DO l=llb,lle
       DO j=jj_begin,jj_end
         DO i=ii_begin,ii_end
@@ -795,16 +769,17 @@
   END SUBROUTINE compute_gradiv
   
-  SUBROUTINE compute_divgrad(theta,divgrad_i,ll)
+  SUBROUTINE compute_divgrad(theta,divgrad_i,llb,lle)
   USE icosa
   IMPLICIT NONE
-    INTEGER,INTENT(IN)     :: ll
-    REAL(rstd),INTENT(IN)  :: theta(iim*jjm,ll)
-    REAL(rstd),INTENT(OUT) :: divgrad_i(iim*jjm,ll)
-    REAL(rstd)  :: grad_e(3*iim*jjm,ll)
+    INTEGER,INTENT(IN)     :: llb
+    INTEGER,INTENT(IN)     :: lle
+    REAL(rstd),INTENT(IN)  :: theta(iim*jjm,llm)
+    REAL(rstd),INTENT(OUT) :: divgrad_i(iim*jjm,llm)
+    REAL(rstd)  :: grad_e(3*iim*jjm,llb:lle)
 
     INTEGER :: i,j,n,l
 
        
-    DO l=1,ll
+    DO l=llb,lle
       DO j=jj_begin-1,jj_end+1
         DO i=ii_begin-1,ii_end+1
@@ -823,5 +798,5 @@
     
     
-    DO l=1,ll
+    DO l=llb,lle
       DO j=jj_begin,jj_end
         DO i=ii_begin,ii_end
@@ -837,5 +812,5 @@
     ENDDO
    
-    DO l=1,ll
+    DO l=llb,lle
       DO j=jj_begin,jj_end
         DO i=ii_begin,ii_end
@@ -849,15 +824,16 @@
 
     
-  SUBROUTINE compute_gradrot(ue,gradrot_e,ll)
+  SUBROUTINE compute_gradrot(ue,gradrot_e,llb,lle)
   USE icosa
   IMPLICIT NONE
-    INTEGER,INTENT(IN)     :: ll
-    REAL(rstd),INTENT(IN)  :: ue(iim*3*jjm,ll)
-    REAL(rstd),INTENT(OUT) :: gradrot_e(iim*3*jjm,ll)
-    REAL(rstd) :: rot_v(2*iim*jjm,ll)
+    INTEGER,INTENT(IN)     :: llb
+    INTEGER,INTENT(IN)     :: lle
+    REAL(rstd),INTENT(IN)  :: ue(iim*3*jjm,llm)
+    REAL(rstd),INTENT(OUT) :: gradrot_e(iim*3*jjm,llm)
+    REAL(rstd) :: rot_v(2*iim*jjm,llb:lle)
 
     INTEGER :: i,j,n,l
      
-    DO l=1,ll
+    DO l=llb,lle
       DO j=jj_begin-1,jj_end+1
         DO i=ii_begin-1,ii_end+1
@@ -876,5 +852,5 @@
     ENDDO                              
   
-    DO l=1,ll
+    DO l=llb,lle
       DO j=jj_begin,jj_end
         DO i=ii_begin,ii_end
@@ -891,5 +867,5 @@
     ENDDO
 
-    DO l=1,ll
+    DO l=llb,lle
       DO j=jj_begin,jj_end
         DO i=ii_begin,ii_end
